/* eslint-disable no-use-before-define */
/* eslint-disable react/destructuring-assignment */
/* eslint-disable no-nested-ternary */
import React from 'react';
import {
  View, StyleSheet, Platform, Dimensions,
} from 'react-native';
import debounce from 'debounce';

import DebugListView from './debug-list-view';
import debugService from './debug-service';


const dimen = Dimensions.get('window');

const DEVICE_WIDTH = dimen.width;
const DEVICE_HEIGHT = dimen.height;

const isIOS = Platform.OS === 'ios';
// iPhoneX
const X_WIDTH = 375;
const X_HEIGHT = 812;
const XR_MAX_WIDTH = 414;
const XR_MAX_HEIGHT = 896;

const isIphoneX = (isIOS
&& ((DEVICE_HEIGHT === X_HEIGHT && DEVICE_WIDTH === X_WIDTH)
    || (DEVICE_HEIGHT === X_WIDTH && DEVICE_WIDTH === X_HEIGHT))) || (isIOS
    && ((DEVICE_HEIGHT === XR_MAX_HEIGHT && DEVICE_WIDTH === XR_MAX_WIDTH)
        || (DEVICE_HEIGHT === XR_MAX_WIDTH && DEVICE_WIDTH === XR_MAX_HEIGHT)));

export const topHeight = Platform.OS === 'ios' ? (isIphoneX ? 44 : 20) : 0;


export default class DebugView extends React.Component {
  constructor() {
    super();
    this.state = {
      rows: [],
    };
    this.unmounted = false;
    this.updateDebounced = debounce(this.update.bind(this), 150);
  }

  componentWillUnmount() {
    this.unmounted = true;
    if (this.listner) {
      this.listner();
    }
  }

  update(data) {
    if (data) {
      if (!this.unmounted) {
        this.setState({ rows: data });
      }
    }
  }

  componentWillMount() {
    this.listner = debugService.onDebugRowsChanged(this.updateDebounced);
  }

  render() {
    return (
      <View style={styles.container}>
        <DebugListView
          onPressHide={this.props.onPressHide}
          rows={this.state.rows}
          {...this.props}
        />
      </View>
    );
  }
}

DebugView.defauleProps = {
  onPressHide: () => {},
};

const styles = StyleSheet.create({
  container: {
    flex: 1,
    paddingTop: topHeight,
  },
});
